procedure TriangleFLATZ(X1,Y1,Z1,X2,Y2,Z2,X3,Y3,Z3:single;color:dword;where:gfxImage);
var
      Dx12,Dx23,Dx31,Dy12,Dy23,Dy31:single;
      minx,maxx,miny,maxy:longint;
      C1,C2,C3:single;
      Cx1,Cx2,Cx3,Cy1,Cy2,Cy3:single;
      x,y:longint;

      a,b,c,D:single;
      Z,initialZ,tempZ:single;
      dx,dy:single;

begin

    // Deltas

    Dx12:= x1 - x2;
    Dx23:= x2 - x3;
    Dx31:= x3 - x1;
    Dy12:= y1 - y2;
    Dy23:= y2 - y3;
    Dy31:= y3 - y1;


    // Bounding rectangle

    minx:=round(min(x1,min(x2, x3)));
    maxx:=round(max(x1,max(x2, x3)));
    miny:=round(min(y1,min(y2, y3)));
    maxy:=round(max(y1,max(y2, y3)));



        // the plane equation for this triangle: ax + by + cz = d
        a:= (y2 - y1)*(z3 - z1) - (y3 - y1)*(z2 - z1);
        b:= (x2 - x1)*(z3 - z1) - (x3 - x1)*(z2 - z1);
        c:= (x2 - x1)*(y3 - y1) - (x3 - x1)*(y2 - y1);
        D:= -x1*a + y1*b - z1*c;



    // Constant part of half-edge functions

    C1:= Dy12 * x1 - Dx12 * y1;
    C2:= Dy23 * x2 - Dx23 * y2;
    C3:= Dy31 * x3 - Dx31 * y3;


    Cy1:= C1 + Dx12 * miny - Dy12 * minx;
    Cy2:= C2 + Dx23 * miny - Dy23 * minx;
    Cy3:= C3 + Dx31 * miny - Dy31 * minx;



    if c = 0 then exit;

    initialZ:= (A * -(minx) + B * -(miny) -D) / C;
    dx:= -A / C;
    dy:= -B / C;


    // Scan through bounding rectangle

    for y:= miny to maxy do begin

        // Start value for horizontal scan
        Cx1:= Cy1;
        Cx2:= Cy2;
        Cx3:= Cy3;
        Z:=initialZ;

        for x:= minx to maxx do begin

            if (Cx1 > 0) and (Cx2 > 0) and (Cx3 > 0) then begin
                        Z:=Z+dx;
                        tempZ:=z-zAddValue;

                        if tempZ > zbuffer[x,y] then begin

                            PutPixel32(x, y, color, where);


                            zbuffer[x,y]:=tempZ;
                        end;
            end;

            initialZ:=initialZ+dy;

            Cx1:=Cx1-Dy12;
            Cx2:=Cx2-Dy23;
            Cx3:=Cx3-Dy31;

        end;

        Cy1:= Cy1+Dx12;
        Cy2:= Cy2+Dx23;
        Cy3:= Cy3+Dx31;

     end;

end;
